package uk.ac.open.kmi.watson.clientapi.test;

import java.rmi.RemoteException;
import java.util.Vector;

import uk.ac.open.kmi.watson.clientapi.EntitySearch;
import uk.ac.open.kmi.watson.clientapi.EntitySearchServiceLocator;
import uk.ac.open.kmi.watson.clientapi.OntologySearch;
import uk.ac.open.kmi.watson.clientapi.OntologySearchServiceLocator;
import uk.ac.open.kmi.watson.clientapi.WatsonService;

public class SearchKeyword { 
	
	private OntologySearch os;
	private EntitySearch es;
	
	public SearchKeyword(){
		OntologySearchServiceLocator locator = new OntologySearchServiceLocator();
		EntitySearchServiceLocator locatore = new EntitySearchServiceLocator();
		try{
			os = locator.getUrnOntologySearch();
			es = locatore.getUrnEntitySearch();
		}
		catch (Exception e) {
			e.printStackTrace();
			System.out.println(e.getCause());
		}
	}
	
	public static void main(String[] args){
		// if (args.length!=1) usage();
		SearchKeyword sk = new SearchKeyword();
		String kw = "madrid";
		String [] ontos = sk.getSCs(kw);
		System.out.println("Found "+ontos.length+" SCs");
		String [][] ents = sk.getEntitites(ontos, kw);
		System.out.println("Found "+ents.length+" ents");
		for (String[] ent : ents) System.out.println(ent[0]+" -- "+ent[1]);
		String [][] relTo = sk.getRT(ents); 
		System.out.println("Found "+relTo.length+" RT");
		for (String[] rt : relTo) {
			for (String s : rt)
				System.out.print(s+" -- ");
			System.out.println();
		}
	}

	private String[][] getRT(String[][] ents) {
		for (String[] ent : ents){
			System.out.println("**"+ent[0] + " -- " + ent[1]+"**");
			String[][] rts = new String[0][];
			try {
				rts = es.getRelationsTo(ent[0], ent[1]);
			} catch (RemoteException e) {
				// TODO Auto-generated catch block
				e.printStackTrace();
			}
			for (String[] rt : rts) {
				for (String s : rt)
					System.out.print(" -- "+s);
				System.out.println();
			}
		}
		return null;
	}

	private String[] getSCs(String kw) {
		String [] params = {kw};
		int scope = 1+2+4+8+16+32;
		int entities = 1+2+4+8+16+32;
		String [] results = new String[0];
		try {
			results = os.getSemanticContentByKeywordsWithRestrictions(params, scope, entities, WatsonService.EXACT_MATCH);
		} catch (RemoteException e) {
			e.printStackTrace();
		}	
		return results;
	}

	private String[][] getEntitites(String[] ontos, String kw) {
		String [] result;
		Vector<String[]> results = new Vector<String[]>();
		for (String onto : ontos){
			try {
				result = es.getEntitiesByKeywordWithRestriction(onto, kw, 255, 255, WatsonService.EXACT_MATCH);
				for (String res : result){
					String [] couple = new String[2];
					couple[0] = onto; couple[1] = res;
					results.add(couple);
				}
			} catch (RemoteException e) {
				e.printStackTrace();
			}
		}
		return toArray(results);
	}

	private String[][] toArray(Vector<String[]> results) {
		int i = 0;
		String[][] ret = new String[results.size()][];
		for (String[] re : results) ret[i++] = re; 
		return ret;
	}

	private static void usage() {
	 System.out.println("Usage: java SearchKeyword <keyword>");
	}
	
	
}
